const GOOGLE = 1;
const YAHOO = 2;
const LIVE = 3;

var FS_SearchConst = [GOOGLE,YAHOO,LIVE];
var FS_SearchFilter = [
/^http:\/\/w+\.google\.[a-z\.]+\/(#q|#hl|webhp\?|search\?|custom\?|sponsoredlinks\?|mac\?|bsd\?|linux\?|microsoft\?|unclesam\?)/i,
/^http:\/\/([a-z]+\.)?((www|search|myweb|myweb2|one\.search|espanol|one\.search|search\.cn)|(one.cn))\.yahoo\.[a-z\.]+\/(search|custom|s)/i,
/\.bing\.com\/search/i];
var FS_DomainSupport = [null, "google.com", "yahoo.com", "msn.com"];
var FS_ValidLink = [null, validlink_google, validlink_yahoo2, validlink_msn];
var FS_SkipLink = [null, /mailto:|javascript:/i, /mailto:|javascript:/i, /(search|\.mail)?\.(msnscache)?\.com|mailto:|javascript:/i];

const YAHOO_C = 2;
const HOTMAIL = 3;
const YAHOO_B = 4;
const YAHOO_A = 5;

var FS_MailConst = [GOOGLE,YAHOO_C,HOTMAIL,YAHOO_B,YAHOO_A];
var FS_MailFilter = [
/^https?:\/\/mail\.google\.com/i,
/^https?:\/\/[a-z][a-z]\.([a-z]|\d)+\.mail\.(yahoo)\.[a-z\.]+\/ym\//i,
/^https?:\/\/mail\.live\.com/i,
/^https?:\/\/[a-z][a-z]\.([a-z]|\d)+\.mail\.(yahoo)\.[a-z\.]+\/mc\//i,
/^https?:\/\/[a-z][a-z]\.([a-z]|\d)+\.mail\.(yahoo)\.[a-z\.]+\/dc\//i];

var FS_MailSkipLink = [null, /mail\.google\.com|mailto:|javascript:/i, /\.yahoo\.|mailto:|javascript:/i, /(search|\.mail)?\.(live|msn|msnscache)?\.com|mailto:|javascript:/i, /mailto:|javascript:/i];
var FS_MailXPath = [
null,
"//div[@class='mb' or @id='message']//a",
"//div[@class='mb' or @id='message']//a",
"//div[@class='mb' or @id='message']//a",
"//a]"
];
var FS_MailValidLink = [null, validlink_gmail, validlink_ymail, validlink_hmail, validlink_ymailb, validlink_ymaila];
//var FS_MailFrameMatch = [null, null, null, null, null,/^messageAreaIframe|^//viewArea_Test_/i]

var FS_MailFrameMatch = [null, null, null, null, null, /^messageAreaIframe|^/i]//viewArea_Test_/i]]


const WIKI = 1;
const DMOZ = 2;
const DELICIOUS = 3;
const DIGG =4;

var FS_OtherConst = [WIKI, DMOZ, DELICIOUS,DIGG];
var FS_OtherFilter = [
/\.wikipedia\.org/i,
/\.?dmoz\.org/i,
/del\.icio\.us/i,
/digg\.com/i];
var FS_OtherXPath = [
null,
//"//a[@class='external text' and not(contains(@href,'wikipedia.org'))]",
"//a",
//"//a[not(contains(@href,'dmoz.org'))]"
"//a",
"//a",
"//h3/a"
];
var FS_OtherSkipLink = [null, /http:\/\/([a-z-]+\.)*wikipedia\.org/i, /http:\/\/([a-z-]+\.)*dmoz\.org/i, /https?:\/\/([a-z]+\.)?del\.icio\.us/i, /http:\/\/([a-z-]+\.)*digg\.com/i];
//var FS_XPathLink = [null,"//a[starts-with(@id,'an') or starts-with(@id,'pa') or @class='l' or @class='yschttl']"];

var FS_DemandConst = [GOOGLE,YAHOO];
var FS_DemandFilter = [/\.google\.com/i,/\.yahoo\.com/i];
var FS_DemandValid = [null, validlink_google, validlink_yahoo];

function getSearchIndex(doc_loc)
{
  for(var i=0;i<FS_SearchFilter.length;i++)
  {
    if( doc_loc.match(FS_SearchFilter[i]) ) return FS_SearchConst[i];
  }
  return 0;
}

function getMailIndex(doc_loc)
{
	for(var i=0;i<FS_MailFilter.length;i++)
	{
		if( doc_loc.match(FS_MailFilter[i]) ) return FS_MailConst[i];
	}
	return 0;
}

function getOtherIndex(doc_loc)
{
	for(var i=0;i<FS_OtherFilter.length;i++)
	{
		if( doc_loc.match(FS_OtherFilter[i]) ) return FS_OtherConst[i];
	}
	return 0;
}

function getDemandFilter(doc_loc)
{
	for(var i=0;i<FS_DemandFilter.length;i++)
	{
		if( doc_loc.match(FS_DemandFilter[i]) ) return FS_DemandConst[i];
	}
	return 0;
}

function validlink_google(link) {
	//if (link.className && link.className == "l") return link.href;
		function checkMouseover() {
		
		if (link.href.match(/\/aclk/))
		{
  		return null;
    }   
    		
		if (link.href.match(/\/url\?q/))
		{

		  //var href = unescape(link.href);
		  var href = link.href;
      href = href.slice(href.indexOf("q=")+2);
      var idx = href.indexOf("&");
      if (idx != -1)
      	href = href.substring(0,idx);
      	
      if (href.indexOf("://") == -1)
        return "http://www." + FS_DomainSupport[1] + href;
      else
        return href;
    }
    
		if (link.href.match(/\/url\?url/))
		{
		  var href = unescape(link.href);
		  var href = link.href;
      href = href.slice(href.indexOf("url=")+4);
      var idx = href.indexOf("&");
      if (idx != -1)
      	href = href.substring(0,idx);
     	
      return href;
    }
    
    /*
    if (!link.id)
     {
      
      var link2=link.parentNode;
      //alert(link2.className);
      if (link2.className && link2.className == "r") 
        return link.href;
      
      return null;
    }
    */
    
		if (!link.id) return null;
		if (link.id.match(/^a[wn]/)) {
			linkTrav = link;
			while (linkTrav.nextSibling && linkTrav.nextSibling.tagName != "A") {
				linkTrav = linkTrav.nextSibling;
				if (linkTrav.tagName == "FONT") return linkTrav.textContent;
			}
			return null;
		}
//		} else if (link.id.match(/^pa/)) {
//			spans = link.parentNode.getElementsByTagName("SPAN");
//			for (var s = 0; s < spans.length; s++)
//				if (spans[s].getAttribute("class") && spans[s].getAttribute("class") == "a") 
//				{
//				  dump("sponsor ads " + spans[s].textContent);
//					return spans[s].textContent;
//       }
//			return null;
//		} else
    else
			return null;
	}
	
	// ignore reputation icon on top of the google maps links
  if(link.innerHTML.match(/red_icons_A_G.png/gi))
	{
	 return null;
  }	

	href = checkMouseover();
	if (href) return href;
	href = unescape(link.href);
	href = link.href;
	var hrefpath = href;
	
  var link2=link.parentNode;
	//-elvinlee 160708 no sponsors links if( (link2.className && link2.className == "r") ||(link.className && link.className == "l") || (link.id && link.id.match(/^(a[wn])|(p[an])/)))
	if( (link2.className && link2.className == "r") ||(link.className && link.className == "l") )
  {
	  //dump("class matched with " + hrefpath + "\n");
		if (hrefpath.match(/\/pagead\/iclk\?/)) {
      href = href.slice(href.indexOf("adurl=")+6);
      var idx = href.indexOf("&");
      if (idx != -1)
      	href = href.substring(0,idx);
      return href;
	  }
    if (hrefpath.match(/(\/url\?)|(\/aclk\?)/)) {
      href = href.slice(href.indexOf("q=")+2);
      var idx = href.indexOf("&");
      if (idx != -1)
      	href = href.substring(0,idx);
      if (href == null)
      {
        href = unescape(link.href);
      	href = href.slice(href.indexOf("url=")+4);
       	var idx = href.indexOf("&");
        if (idx != -1)
      	 href = href.substring(0,idx);
      }
      
      return href;
  	}
    if (hrefpath.match(/\/interstitial\?/)) {
      //dump("match interstial\n");
      href = href.slice(href.indexOf("url=")+4);
      var idx = href.indexOf("&");
      if (idx != -1)
      	href = href.substring(0,idx);
    }
    
    return href;
  }
/*
	if(!(link.className && link.className == "l") && href.match(/google/))
	{
  	var noprotocol = href.slice(href.indexOf("//")+2);
  	firstslash = noprotocol.indexOf("/");
  	if (firstslash != -1) hrefpath = noprotocol.slice(firstslash);
  } else {
    if(link.className && link.className == "l")
      //return href;
      hrefpath=href;
  }
	if (hrefpath.match(/^\/pagead\/iclk\?/) && href.match(/google/)) {
		href = href.slice(href.indexOf("adurl=")+6);
		var idx = href.indexOf("&");
		if (idx != -1)
			href = href.substring(0,idx);
		return href;
	}
	if (hrefpath.match(/^(\/url\?)|(\/aclk\?)/) && href.match(/google/)) {
	 dump("matched url??...\n");
		href = href.slice(href.indexOf("q=")+2);
		var idx = href.indexOf("&");
		if (idx != -1)
			href = href.substring(0,idx);
		if (href == null)
		{
		  href = unescape(link.href);
  		href = href.slice(href.indexOf("url=")+4);
	   	var idx = href.indexOf("&");
		  if (idx != -1)
			 href = href.substring(0,idx);
    }
    dump("result = " + href + "\n");
		return href;
	}
	if (hrefpath.match(/^\/interstitial\?/) && href.match(/google/)) {
		href = href.slice(href.indexOf("url=")+4);
		var idx = href.indexOf("&");
		if (idx != -1)
			href = href.substring(0,idx);
		return href;
	}
*/
	return null;	
}

function validlink_google2(link) {

	if (link.innerHTML.match(/(^Yahoo&nbsp;Finance$|^MSN&nbsp;Money$|^MarketWatch$|^CNN&nbsp;Money$|^Reuters$)/)) return null;
	if(link.innerHTML.match(/Kurs fr/) && link.parentNode.className=="e" && link.parentNode.tagName=="P")
		return null;
	if(link.parentNode.tagName=="FONT" && link.parentNode.className=="a")
		return null;
	if (link.id && link.id.match(/^fbql/)) return null;
	function checkMouseover() {
		if (!link.id) return null;
		if (link.id.match(/^a[wn]/)) {
			linkTrav = link;
			while (linkTrav.nextSibling && linkTrav.nextSibling.tagName != "A") {
				linkTrav = linkTrav.nextSibling;
				if (linkTrav.tagName == "FONT") return linkTrav.textContent;
			}
			return null;
		} else if (link.id.match(/^pa/)) {
			spans = link.parentNode.getElementsByTagName("SPAN");
			for (var s = 0; s < spans.length; s++)
				if (spans[s].getAttribute("class") && spans[s].getAttribute("class") == "a")
					return spans[s].textContent;
			return null;
		} else
			return null;
	}
	href = checkMouseover();
	if (href) return href;
	href = unescape(link.href);
    if (href == null || href.length < 4 || !href.match(/^http/) || href.match(/oi=dict/) || href.match(/oi=map/) || href.match(/oi=smap/) || href.match(/oi=stock/) || href.indexOf("http://www.chillingeffects.org/dmca512/notice.cgi?")==0  || href.match(/\?q=cache:/) || href.match(/127\.0\.0\.1/) || href.match(/localhost/) || href.indexOf("//") == -1)
		return null;
	if(link.className && link.className.match(/fl/) && link.parentNode.tagName=="FONT") return null;
	var noprotocol = href.slice(href.indexOf("//")+2);
	var hrefpath = "/";
	firstslash = noprotocol.indexOf("/");
	if (firstslash != -1) hrefpath = noprotocol.slice(firstslash);
	if (hrefpath.match(/^\/pagead\/iclk\?/) && href.match(/google/)) {
		href = href.slice(href.indexOf("adurl=")+6);
		var idx = href.indexOf("&");
		if (idx != -1)
			href = href.substring(0,idx);
		return href;
	}
	if (hrefpath.match(/^\/url\?/) && href.match(/google/)) {
		href = href.slice(href.indexOf("q=")+2);
		var idx = href.indexOf("&");
		if (idx != -1)
			href = href.substring(0,idx);
		return href;
	}
	if (hrefpath.match(/^\/interstitial\?/) && href.match(/google/)) {
                var urlmatch = href.match(/[\?&]url=([^&]*)/);
                if (urlmatch) return urlmatch[1];
        }
  if(!link.className || !link.className.match(/^l/ig)) return null;
	return href;
}

function validlink_msn(link)
{
    try
		{
			if(link.href.match(/mailto:|javascript:/i)) return null;
		 
		} catch ( e )
		{
			//dump(e +"\n");
			return null;
		}

	var parent = link.parentNode;
	if (parent)
{
	var parentparent = parent.parentNode;						
    if(parentparent)
    {
      //alert(link.parentNode.tagName);
      var tagName =  parent.tagName;
	    var className = parentparent.className;
	    
      if(tagName && className && tagName.indexOf("H3")!=-1 && (className == 'sb_tlst' || className == 'nc_tc'))
      {
        var strAtt = link.getAttribute("onmousedown");
        if(strAtt.indexOf("ID=SERP")!=-1)
        {
           return link.href; 
        }
      }
    }
}

    return null;
}

function validlink_yahoo2(link) {
	if(link.className.match(/^yschttl/i))
  {
    var yahooRegion = 0; // Most of the yahoo regional site
     
    if(link.href.toLowerCase().indexOf("/*-http%3a//") != -1)
       yahooRegion = 1; // Yahoo japan
    else if(link.href.toLowerCase().indexOf("**http%3a//") != -1)
      yahooRegion = 2; // Yahoo russian
    else if(link.href.toLowerCase().indexOf("/**http://") != -1)
      yahooRegion = 3; // Yahoo other region
      
      switch(yahooRegion)
      {
      case 0:
        return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("/**http%3a//")+8); // Rex: 13/03/09 - Update yahoo search link parameter length
      case 1:
        return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("*-")+11); // Rex: 13/03/09 - Update yahoo search link parameter length
      case 2:
        return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("**")+11); // Rex: 13/03/09 - Update yahoo search link parameter length
      case 3.:
        return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("**")+9); // Rex: 13/03/09 - Update yahoo search link parameter length
      default:
        return "";
             
      }
     
    //return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("*-")+11); // Rex: 13/03/09 - Update yahoo search link parameter length
  
    //return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("/**http%3a//")+12);
    //return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("/**http%3a//")+8); // Rex: 13/03/09 - Update yahoo search link parameter length
  }
	var tDiv = link.parentNode;
	//dump("tag: " + tDiv.tagName + "\n");
	while (tDiv)
	{
//	dump("Link: " + link.href + "\n");
//  dump("Tag: " + tDiv.tagName + "\n");
//	dump("ID: " + tDiv.id + "\n");
//	dump("Class: " + tDiv.className + "\n");
	  //if(tDiv.tagName == "DIV" && (tDiv.id == "yschiy")) break;
	  if(tDiv.tagName == "DIV" && (tDiv.id == "yschiy" || tDiv.className == "yst-web" || tDiv.className == "ymc" )) break;
 		tDiv = tDiv.parentNode;
		//dump("tag: " + tDiv.tagName + "\n");
	}
		
	if(tDiv && (tDiv.id == "yschiy"))
	{s
  	 //dump("tag: " + tDiv.tagName + "\n");
	   //dump("id: " + tDiv.id + "\n");
	   return "http://"+ link.href.slice(link.href.toLowerCase().indexOf("/**http%3a//")+12);
  }
	if(tDiv && (tDiv.className == "yst-web"))
	{
    if(link.href.toLowerCase().indexOf("http://203.209.253.250/snap/") == -1 && link.href.toLowerCase().indexOf("http://fanyi.cn.yahoo.com/") == -1 )
	   return link.href;
  }
	if(tDiv && (tDiv.className == "ymc"))
	{
	  //if(link.href.toLowerCase().indexOf("http://203.212.171.180/search/") == -1 && link.href.toLowerCase().indexOf("WebDoc") == -1)
	  if(link.href.toLowerCase().indexOf("http://203.212.171.180/search/") == -1 && link.href.toLowerCase().indexOf("http://kr.search.") == -1 && link.href.toLowerCase().indexOf("http://kr.srd.") == -1)
	   return link.href;
  }  

  return null;
	
	//dump("class: " + tDiv.className + "\n");
}

function validlink_yahoo(link) {
	function ct(ctr,cte) {
		while(cte) {
			if (ctr == cte) return true;
			cte = cte.parentNode;
		}
		return false;
	}
	if(link.ownerDocument.location.host.match(/kr\.search\.yahoo\.com/) && link.parentNode && link.parentNode.tagName=="SPAN")
			return null;
	if(link.ownerDocument.location.host.match(/hk\.search\.yahoo\.com/) && link.parentNode && link.parentNode.className && (link.parentNode.className=="linkblock" || link.parentNode.className=="eysm"))
		return null;
	if (link.ownerDocument.location.host.match(/search\.cn\.yahoo.com$/))
	{
		if(link.parentNode.tagName=="DIV" && link.parentNode.className && link.parentNode.className=="rc")
		{
			var tDiv=link.getElementsByTagName("DIV")
			for(var i=0;i<tDiv.length;i++)
			{
				if(tDiv[i].className && tDiv[i].className=="rel")
					return tDiv[i].textContent;
			}
		}
		if(link.parentNode.tagName=="TD" && link.parentNode.className && link.parentNode.className=="ad")
		{
			var tSpan=link.getElementsByTagName("SPAN")
			for(var i=0;i<tSpan.length;i++)
			{
				if(tSpan[i].className && tSpan[i].className=="r1")
					return tSpan[i].textContent.slice(3)
			}
		}
		if(link.parentNode.tagName=="DIV" && link.parentNode.className && link.parentNode.className=="i")
		{
			var lIndHttp=link.href.lastIndexOf("http")
			return link.href.slice(lIndHttp)
		}
		return null;
    }
	if(link.ownerDocument.location.host.match(/au\.search\.yahoo\.com/) && link.className=="yschttl")
	{
		var traverseNode=link.parentNode;
		traverseNode=traverseNode.nextSibling;
		while(traverseNode)
		{
			if(traverseNode.tagName=="EM" && traverseNode.className=="yschurl")
				return traverseNode.textContent;
			traverseNode=traverseNode.nextSibling;
		}
	}
	if (ct(link.ownerDocument.getElementById("ygma"),link)) return null;
	if(link.ownerDocument.getElementById("yschweb"))
	{
		if(link.parentNode && link.parentNode.tagName=="DIV")
		{
			if(link.parentNode.parentNode && link.parentNode.parentNode.tagName=="LI")
			{
				if(link.parentNode.parentNode.parentNode && link.parentNode.parentNode.parentNode.tagName=="UL")
				{
					if(link.parentNode.parentNode.parentNode.parentNode && link.parentNode.parentNode.parentNode.parentNode.tagName=="DIV" && link.parentNode.parentNode.parentNode.parentNode.hasAttribute && link.parentNode.parentNode.parentNode.parentNode.getAttribute("class")=="yschspns")
					{
						var traverseNode=link
						while(traverseNode)
						{
							if(traverseNode.tagName=="EM")
								return traverseNode.textContent
							traverseNode=traverseNode.nextSibling
						}
					}
				}
			}
		}
		if(link.parentNode && link.parentNode.tagName=="LI")
		{
			if(link.parentNode.parentNode && link.parentNode.parentNode.tagName=="UL")
			{
				if(link.parentNode.parentNode.parentNode && link.parentNode.parentNode.parentNode.tagName=="DIV" && link.parentNode.parentNode.parentNode.id && link.parentNode.parentNode.parentNode.id=="yschsec")
				{
					var traverseNode=link
					while(traverseNode)
					{
						if(traverseNode.tagName=="EM")
							return traverseNode.textContent
						traverseNode=traverseNode.nextSibling
					}
				}
			}
		}
	}
	if (ct(link.ownerDocument.getElementById("yschweb"),link)) {
		if (link.getAttribute("class")) {
			if (link.getAttribute("class") != "yschttl")
				return null;
		} else return null;
	}
	if (link.parentNode && link.parentNode.getAttribute("class") && link.parentNode.getAttribute("class") == "yschprom") return null;
	if (link.id) {
            var idhref = link.id.match(/^http:\/\/.*/);
            if (idhref) return idhref[0];
        }
        href = unescape(link.href);
	if (href.match(/\.pdf#search/) || href.match(/\.pdf$/)) return href;
	if (href.length < 4 || !href.match("^http") || href.match(/cache\?/) || !href.match(/\*[\*-]/))
		return null;
	var adpos = href.indexOf("&yargs=");
	if (adpos != -1)
		return href.slice(adpos+7);
	var regpos = href.indexOf("**");
	if (regpos == -1) regpos = href.indexOf("*-");
	if (regpos != -1) {
		href = 	href.slice(regpos+2);
		if (href.match(/\.yahoo\./) && href.match(/click\?u=/)) {
			href = href.slice(href.indexOf("click?u=")+8);
			return href;
		}
		else return href;
	}
	return null;
}

function validlink_hmail(link) {
  //dump("valid hmail called " + link.href + "\n");
	var tDiv = link.parentNode;
	while(tDiv /*&& tDiv.tagName != "DIV" */ && tDiv.id != "MsgContainer")
	{
		tDiv = tDiv.parentNode;
	}
	//dump("verify result " + tDiv +"\n");
	if(tDiv)
  {
   	//dump("detail result " + tDiv.tagName + " " + tDiv.id +"\n");
   	//dump("div: " + tDiv.id +"\n");
   	//dump("class: " + tDiv.className +"\n");
   	//dump("link: " + link.href +"\n");
		return link.href;
  }
	return null;
}

function validlink_ymail(link) {
  //dump("valid ymail called " + link.href + "\n");s
  var tDiv = null;
  var bYahooMailJpn = false;
  var yahooMailJpn = window.content.document.location.href;

  if(yahooMailJpn.indexOf("mail.yahoo.co.jp") == -1)
  {
    bYahooMailJpn = false;
    tDiv = link.parentNode;
    //dump("Yahoo other\n");
  } else {
    bYahooMailJpn = true;
    tDiv = link.parentNode.parentNode.parentNode.parentNode.parentNode;
    //dump("Yahoo Japan\n");
  }
  /*
  if(link.href.indexOf("allrecipes") != -1)
	{
    dump("Link: " + link.href + "\n");
    dump("Class: " + tDiv.className + "\n");
    dump("Tag: " + tDiv.tagName + "\n");
    dump("ID: " + tDiv.id + "\n");
 	}
	*/
	
	while(tDiv /*&& tDiv.tagName != "DIV" */ && tDiv.className != "msgbody clearfix" )
	//while(tDiv /*&& tDiv.tagName != "DIV" */ && tDiv.className != "gmail_quote" || tDiv.id.indexOf("yiv") == -1")
  {
    tDiv = tDiv.parenstNode;
  }
  
	
	//dump("verify result " + tDiv +"\n");
/*  if(tDiv)
  {
 	  //dump("detail result " + tDiv.tagName + " " + tDiv.id +"\n");
    return link.href;
  }
*/	
	//dump("verify result " + tDiv +"\n");
	if(bYahooMailJpn)
	{
    return link.href;
  } else {
  	//dump("verify result " + tDiv +"\n");
    if(tDiv)
    {
      return link.href;
    } 
  }

	return null;
}

function validlink_gmail(link) {
	var tDiv = link.parentNode;
	//while(tDiv /*&& tDiv.tagName != "DIV" */ && (tDiv.className != "mb" || tDiv.className != "msg"))
	while(tDiv /*&& tDiv.tagName != "DIV" */ && tDiv.className != "mb" && tDiv.className != "msg" && tDiv.className != "YrSjGe" && tDiv.className != "HprMsc" )
	{
		tDiv = tDiv.parentNode;
	}
	//dump("verify result " + tDiv +"\n");
	if(tDiv)
  {
   	//dump("detail result " + tDiv.tagName + " " + tDiv.id +"\n");
		return link.href;
  }
	return null;
}

function validlink_ymaila(link) {
  //dump("valid ymaila called " + link.href + "\n");
	var tDiv = link.parentNode;
	while(tDiv /*&& tDiv.tagName != "DIV" */ && tDiv.id != "lwPreview")
	{
		tDiv = tDiv.parentNode;
	}
	if(tDiv && tDiv.id == "lwPreview")
  {
 		return null;
  }
 	return link.href;
}

function validlink_ymailb(link) {
  //dump("valid ymailb called " + link.href + "\n");
	var tDiv = link.parentNode;
	while(tDiv /*&& tDiv.tagName != "DIV" */ && tDiv.className != "undoreset clearfix")
	{
		tDiv = tDiv.parentNode;
	}
	//dump("verify result " + tDiv +"\n");
	if(tDiv)
  {
   	//dump("detail result " + tDiv.tagName + " " + tDiv.id +"\n");
		return link.href;
  }
	return null;
}


 ///////////////////////////////////////////////////////////////////////////////
